' Datei fr Attiny-Platine von E. Eube, G. Heinrichs und U. Ihlefeldt
' Gibt Stunden, Minuten und Sekunden an LCD aus.

' DCF1 von Pollin an Attiny:
' VDD an +2,5V (!)
' GND an Masse
' PON an Masse
' DATA an PortD.3 <-Kabel-> D3 (Eingang; INT1;  >>>Doch<<< Pull-Up)
' Das Kabel von DATA nach D3 darf erst nach dem Einschalten des
' Mikrocontrollers gesetzt werden; sonst tuscht der DCF-Baustein ein
' Drcken von Ta1 vor -> Probleme beim Bootloader!
' LCD an PortB
' LED zur Kontrolle an PortD.6
' Antenne horizontal und senkrecht zum DCF-Sender
'----------------------------------------------------------------------------

$regfile = "attiny2313.dat"                                 'Attiny2313
$crystal = 4000000                                          '4 MHz
$baud = 9600

'**********************************************************
'******************* Deklarationen ************************

Dim Werte(40) As Byte
Dim Zaehler As Byte
Dim Minuten As Byte
Dim M1 As Byte
Dim S1 As Byte
Dim Stunden As Byte
Dim Sekunden As Byte
Dim Zeit As String * 8
Declare Sub Auswerten()

'****************** Initialisierung ***********************

Ddrb = &B11111111                                           'Port B als Ausgangsport
Ddrd = &B01110000                                           'D4, D5, D6 als Ausgang; Rest als Eingang
Portd = &B00001000                                          'PortD. 3 auf high legen

Config Lcd = 16 * 2                                         'LCD konfigurieren
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.6
Cursor Off

Enable Int1                                                 'vgl. BASCOM-Hilfe...
Config Int1 = Rising
Enable Interrupts
On Int1 Signal
Config Timer1 = Timer , Prescale = 1024


'**********************************************************
'******************** Hauptprogramm ***********************

Wait 3

Cls
Lcd "DCF-Zeit:"

Zaehler = 0
Minuten = 0
Stunden = 0
Sekunden = 0

Do
Loop

'**********************************************************
'******************* Unterprogramme ***********************

Sub Auswerten()
  'Hier werden die Minuten und Stunden aus den Bits 22 bis 34 berechnet
  Minuten = Werte(21)
  M1 = Werte(22) * 2
  Minuten = Minuten + M1
  M1 = Werte(23) * 4
  Minuten = Minuten + M1
  M1 = Werte(24) * 8
  Minuten = Minuten + M1
  M1 = Werte(25) * 10
  Minuten = Minuten + M1
  M1 = Werte(26) * 20
  Minuten = Minuten + M1
  M1 = Werte(27) * 40
  Minuten = Minuten + M1
  Stunden = Werte(29)
  S1 = Werte(30) * 2
  Stunden = Stunden + S1
  S1 = Werte(31) * 4
  Stunden = Stunden + S1
  S1 = Werte(32) * 8
  Stunden = Stunden + S1
  S1 = Werte(33) * 10
  Stunden = Stunden + S1
  S1 = Werte(34) * 20
  Stunden = Stunden + S1

  'Anzeige auf LCD
  Locate 2 , 1
  If Stunden < 10 Then Lcd "0"
  Lcd Stunden ; ":"
  If Minuten < 10 Then Lcd "0"
  Lcd Minuten ; ":"
End Sub


'**********************************************************
'******************Interruptroutinen***********************

Signal:
  Portd.6 = 1                                               'Sekundenblinker
  Waitms 150
  Portd.6 = 0

  Zaehler = Zaehler + 1

  'Wenn kurzes Signal (100 ms), dann jetzt Pind.3 = 0 -> logisch 0, sonst logisch 1
  'Nur die ersten 36 Bits zur spteren Auswertung speichern

  If Zaehler <= 36 Then
     If Pind.3 = 0 Then Werte(zaehler) = 0 Else Werte(zaehler) = 1
  End If

  'Timer1 gibt die Zeit seit dem letzten INT1-Interrupt (minus 150 ms) an.
  'Bei der 59. Sekunde gibt es kein Signal, also wird beim nchsten INT1-Interrupt
  '[Minute voll] die Zeit von 1 s berschritten;
  'dann ist eine Auswertung der empfangenen Bits fllig.

  If Timer1 > 6000 Then                'also nach mehr als ca. 1,5 s
    Call Auswerten()                                        'nur bei voller Minute auswerten, anzeigen und
    Zaehler = 0                                             'Zhler zurcksetzen
  End If

  'Bei jedem INT1-Interrupt:
  Timer1 = 0                                                '
  Sekunden = Zaehler

  Locate 2 , 7
  If Sekunden < 10 Then Lcd "0"
  Lcd Sekunden

Return

'**********************************************************